package checkAlign;
/**
 * Esta clase debria recibir el postscript
 * analizarlo y craer un png
 */
import java.awt.*;
import java.awt.image.*;
import java.awt.RenderingHints;
import javax.imageio.ImageIO;
import javax.swing.*;
import java.io.*;
import java.awt.event.*;

public class ExportPng extends JFrame{
	PanelPng panel = new PanelPng();
	JButton buttonSavePng = new JButton("Save image");
	JScrollPane scrollCanvas = new JScrollPane(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED, JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
	
	public ExportPng(String input){
		Container cp = getContentPane();
		cp.setLayout(new BorderLayout());
		
		panel.setPreferredSize(new Dimension(800,800));
		scrollCanvas.getViewport().add(panel);
		cp.add(scrollCanvas);
		cp.add(buttonSavePng, BorderLayout.SOUTH);
		
		panel.setDocument(input);
		
		buttonSavePng.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent ae){
				panel.export();
			}
		});
	}
	
}

class PanelPng extends JPanel{
	private BufferedImage bImage;	
	private String postscript;
	private int posX = 0;
	private int posY = 0;
	private int docHeight = 0;
	private int docWidth = 0;
	private int marginTop = 50;
	private int marginLeft = 50;
	private int axisHeight = 100;
	private int axisWidth = 480;
	private Image imageA, imageC, imageD, imageE, imageF, 
	imageG,	imageH, imageI,	imageK, imageL, imageM, imageN, 
	imageP, imageQ, imageR, imageS, imageT, imageV, imageW, imageY;
	private Font fontNormal = new Font("Monospaced", Font.PLAIN, 10);
	private Font fontPos = new Font("Dialog", Font.PLAIN, 10);
	
	public PanelPng(){
		loadImages();
	}
	public void paintComponent(Graphics g){
		super.paintComponent(g);
		
		setDocSize();
		
		Graphics2D g2 = (Graphics2D)g;
		
		if (bImage != null){
			g2.drawImage(bImage, null, 0, 0);
		}
	    else{
	        bImage = (BufferedImage)(this.createImage(docWidth, docHeight));
		    Graphics2D gc = bImage.createGraphics();
		    gc.setColor(Color.WHITE);
			gc.fillRect(0, 0, docWidth, docHeight);
			ps2Graphics(gc);
			gc.drawImage(bImage, null, 0, 0);
	    }
	}
	void ps2Graphics(Graphics2D g){
		setDocSize();
		String[] file = postscript.split("\n");
		boolean startRead = false;
		for (int i=0; i<file.length; i++){
			if (startRead){
				if (file[i].endsWith("translate")){
					String[] part = file[i].split(" ");
					translate(Integer.parseInt(part[0]), Integer.parseInt(part[1]));
				}
				if (file[i].compareToIgnoreCase("drawAxis") == 0){
					drawAxis(g);
				}
				if (file[i].endsWith("charPrint")){
					String[] part = file[i].split(" ");
					charPrint(g, part[0].charAt(1), part[1], part[2], part[3], part[4], part[5]);					
				}
				if (file[i].endsWith("posPrint")){
					String[] part = file[i].split(" ");
					String num = part[0].substring(1, part[0].length()-1);					
					posPrint(g, num);
				}
			}
			if (file[i].compareToIgnoreCase("% body") == 0){
				startRead = true;
			}		
		}		
	}
	
	private void translate(int x, int y){
		posX += x;
		posY -= y;
	}
	private void drawAxis(Graphics2D g){
		g.setColor(Color.BLACK);
		g.setFont(new Font("Arial", Font.PLAIN, 10));
		g.drawLine(posX, posY, posX, posY-100);
		g.drawLine(posX, posY, posX+480, posY);
		
		// quarter lines
		for (int i=1; i<=4; i++){
			g.drawLine(posX, posY-i*25, posX-4, posY-i*25);
		}
		
		// bits label
		g.rotate(Math.toRadians(-90));
		g.drawString("bits", -posY + 40, 40);
		g.rotate(Math.toRadians(90));
		
	}
	private void charPrint(Graphics2D g, char letter, String red, String green, String blue, String width, String height){
		int cHeight = (int)(Double.parseDouble(height) * 100);
		double cWidth = Double.parseDouble(width);
		Image imageLetter = null;
		
		switch (letter){
			case 'A': imageLetter = imageA; break;
			case 'C': imageLetter = imageC; break;
			case 'D': imageLetter = imageD; break;
			case 'E': imageLetter = imageE; break;
			case 'F': imageLetter = imageF; break;
			case 'G': imageLetter = imageG; break;
			case 'H': imageLetter = imageH; break;
			case 'I': imageLetter = imageI; break;
			case 'K': imageLetter = imageK; break;
			case 'L': imageLetter = imageL; break;
			case 'M': imageLetter = imageM; break;
			case 'N': imageLetter = imageN; break;
			case 'P': imageLetter = imageP; break;
			case 'Q': imageLetter = imageQ; break;
			case 'R': imageLetter = imageR; break;
			case 'S': imageLetter = imageS; break;
			case 'T': imageLetter = imageT; break;
			case 'V': imageLetter = imageV; break;
			case 'W': imageLetter = imageW; break;
			case 'Y': imageLetter = imageY; break;
		}
		
		try{
			g.drawImage(imageLetter, posX, posY-cHeight, 12, cHeight, this);
		}catch(Exception ex){
			System.out.println("Failed in char print");
			ex.printStackTrace();
		}
	}
	private void posPrint(Graphics2D g, String num){
		// padding for text
		if (num.length() == 1){
			if (num.compareTo("*") == 0){
				num = "  "+num;
			}else{
				num = "00"+num;
			}			
		}else if(num.length() == 2){
			num = "0"+num;
		}
		// rotate and print
		g.rotate(Math.toRadians(-90));
		g.setColor(Color.BLACK);
		g.setFont(fontPos);
		g.setRenderingHint(RenderingHints.KEY_TEXT_ANTIALIASING, RenderingHints.VALUE_TEXT_ANTIALIAS_ON);
		g.drawString(num, -posY-10, posX+10);
		g.setFont(fontNormal);
		g.rotate(Math.toRadians(90));
	}
	private int getDocAxis(String document){
		int countAxis = 0;
		String[] file = document.split("\n");
		boolean startRead = false;
		for (int i=0; i<file.length; i++){
			if (startRead){
				if (file[i].compareToIgnoreCase("drawAxis") == 0){
					countAxis ++;
				}
			}
			if (file[i].compareToIgnoreCase("% body") == 0){
				startRead = true;
			}
		}
		return countAxis;
	}
	private void setDocSize(){
		int numAxis = getDocAxis(postscript);
		docHeight = numAxis * axisHeight + (numAxis-1) * 40 + marginTop * 2;
		docWidth = axisWidth + marginLeft * 2;
		posX = 0;
		posY = 800;
	}
	void export(){
		try{
		    ImageIO.write((RenderedImage)bImage, "png", new File("C:/pepe.png"));
		}catch (Exception ex){
		    System.out.println("Image saving failed");
		    ex.printStackTrace();
		}
	}
	void setDocument(String input){
		postscript = input;
	}
	private void loadImages(){
		try{
			imageA = Toolkit.getDefaultToolkit().getImage("resources/imagenes/a.png");
			imageC = Toolkit.getDefaultToolkit().getImage("resources/imagenes/c.png");
			imageD = Toolkit.getDefaultToolkit().getImage("resources/imagenes/d.png");
			imageE = Toolkit.getDefaultToolkit().getImage("resources/imagenes/e.png");
			imageF = Toolkit.getDefaultToolkit().getImage("resources/imagenes/f.png");
			imageG = Toolkit.getDefaultToolkit().getImage("resources/imagenes/g.png");
			imageH = Toolkit.getDefaultToolkit().getImage("resources/imagenes/h.png");
			imageI = Toolkit.getDefaultToolkit().getImage("resources/imagenes/i.png");
			imageK = Toolkit.getDefaultToolkit().getImage("resources/imagenes/k.png");
			imageL = Toolkit.getDefaultToolkit().getImage("resources/imagenes/l.png");
			imageM = Toolkit.getDefaultToolkit().getImage("resources/imagenes/m.png");
			imageN = Toolkit.getDefaultToolkit().getImage("resources/imagenes/n.png");
			imageP = Toolkit.getDefaultToolkit().getImage("resources/imagenes/p.png");
			imageQ = Toolkit.getDefaultToolkit().getImage("resources/imagenes/q.png");
			imageR = Toolkit.getDefaultToolkit().getImage("resources/imagenes/r.png");
			imageS = Toolkit.getDefaultToolkit().getImage("resources/imagenes/s.png");
			imageT = Toolkit.getDefaultToolkit().getImage("resources/imagenes/t.png");
			imageV = Toolkit.getDefaultToolkit().getImage("resources/imagenes/v.png");
			imageW = Toolkit.getDefaultToolkit().getImage("resources/imagenes/w.png");
			imageY = Toolkit.getDefaultToolkit().getImage("resources/imagenes/y.png");
		}catch(Exception ex){
			System.out.println("Can not load images");
			ex.printStackTrace();
		}
	}
	private void testImages(Graphics2D g){
		try{
			g.drawImage(imageA, 0, 0, 12, 50, this);
			g.drawImage(imageC, 12, 0, this);
			g.drawImage(imageD, 24, 0, this);
			g.drawImage(imageE, 36, 0, this);
			g.drawImage(imageF, 48, 0, this);
			g.drawImage(imageG, 60, 0, this);
			g.drawImage(imageH, 72, 0, this);
			g.drawImage(imageI, 84, 0, this);
			g.drawImage(imageK, 96, 0, this);
			g.drawImage(imageL, 108, 0, this);
			g.drawImage(imageM, 120, 0, this);
			g.drawImage(imageN, 132, 0, this);
			g.drawImage(imageP, 144, 0, this);
			g.drawImage(imageQ, 156, 0, this);
			g.drawImage(imageR, 168, 0, this);
			g.drawImage(imageS, 180, 0, this);
			g.drawImage(imageT, 192, 0, this);
			g.drawImage(imageV, 204, 0, this);
			g.drawImage(imageW, 216, 0, this);
			g.drawImage(imageY, 228, 0, this);
		}catch(Exception ex){
			System.out.println("Failed testing graphics");
			ex.printStackTrace();
		}
	}
}