package checkAlign;

public class Matrix {
	private String matrix;
	private int[][] absMatrix;
	private double[][] freqMatrix;
	private int numSeq = 0;
	private int numLetters = 0;
	private Functions functions = new Functions();
	private boolean protein = false;
	
	
	public Matrix(){		
	}
	void createMatrix(String input, boolean protein){
		this.protein = protein;
		matrix = filterAlignment(input);
		absMatrix = createAbsMatrix(matrix);
		freqMatrix = createFreqMatrix(absMatrix);
		//functions.showMatrix(absMatrix);
	}
	String getMatrix(){
		return matrix;
	}
	private String filterAlignment(String input){
		StringBuffer sb = new StringBuffer();
        String[] lines;
        boolean firstLine = true;
        
        input = input.replaceAll("\r", "");
        input = input.replaceAll(" ", "");
        lines = input.split("\n");
        
        for (int i=0;i<lines.length;i++){
            if (lines[i].startsWith(">")){
                if (!firstLine){
                    sb.append("\n");
                }
                firstLine = false;
            }else{
                sb.append(lines[i]);
            }
        }
        return sb.toString();
	}
	private int getLongSeq(String input){
    	String[] lines = input.split("\n");
    	return lines[0].length();    	
    }
	private int getNumLetters(String input){
    	// detect gaps
    	int letters = 0;
    	boolean isProtein = false;
    	boolean hasGaps = false;
    	int alignLength = input.length();  	
    	
    	
    	// detect gap
    	for (int i=0; i<alignLength; i++){
    		if (input.charAt(i) == '-'){
    			hasGaps = true;
    			break;
    		}
    	}
    	
    	if (protein){
    		if (hasGaps){
    			letters = 21;
    		}else{
    			letters = 20;
    		}
    	}else{
    		if (hasGaps){
    			letters = 5;
    		}else{
    			letters = 4;
    		}
    	}
    	
    	return letters;
    }
	int getNumSeq(int[][] absMatrix){
    	int counter = 0;
    	int numLetters = absMatrix.length;
    	
    	for (int i=0; i<numLetters; i++){
    		counter += absMatrix[i][0];
    	}
    	numSeq = counter;
    	return counter;
    }
	int getNumSeq(){
		return numSeq;
	}
	private int[][] createAbsMatrix(String input){
		// deberia llamar a get num letters y medir el mismo la longitud de la secuencia haciendo un split
    	int absMatrix[][];
    	int numLetters = getNumLetters(input);
    	int longSeq = getLongSeq(input);
    	
    	absMatrix = new int[numLetters][longSeq];    	
    	String[] line = input.split("\n");
    	char letter;
    	
    	// each seq
    	for (int i=0; i<line.length; i++){
    		// each pos
    		for (int j=0; j<longSeq; j++){
    			letter = line[i].charAt(j);
    			if (numLetters == 21){
    				switch(letter){
	    				case 'A': absMatrix[0][j]++; break;
	    				case 'C': absMatrix[1][j]++; break;
	    				case 'D': absMatrix[2][j]++; break;
	    				case 'E': absMatrix[3][j]++; break;
	    				case 'F': absMatrix[4][j]++; break;
	    				case 'G': absMatrix[5][j]++; break;
	    				case 'H': absMatrix[6][j]++; break;
	    				case 'I': absMatrix[7][j]++; break;
	    				case 'K': absMatrix[8][j]++; break;
	    				case 'L': absMatrix[9][j]++; break;
	    				case 'M': absMatrix[10][j]++; break;
	    				case 'N': absMatrix[11][j]++; break;
	    				case 'P': absMatrix[12][j]++; break;
	    				case 'Q': absMatrix[13][j]++; break;
	    				case 'R': absMatrix[14][j]++; break;
	    				case 'S': absMatrix[15][j]++; break;
	    				case 'T': absMatrix[16][j]++; break;
	    				case 'V': absMatrix[17][j]++; break;
	    				case 'W': absMatrix[18][j]++; break;
	    				case 'Y': absMatrix[19][j]++; break;
	    				case '-': absMatrix[20][j]++; break;
	    			}
    			}else if (numLetters == 20){
    				switch(letter){
	    				case 'A': absMatrix[0][j]++; break;
	    				case 'C': absMatrix[1][j]++; break;
	    				case 'D': absMatrix[2][j]++; break;
	    				case 'E': absMatrix[3][j]++; break;
	    				case 'F': absMatrix[4][j]++; break;
	    				case 'G': absMatrix[5][j]++; break;
	    				case 'H': absMatrix[6][j]++; break;
	    				case 'I': absMatrix[7][j]++; break;
	    				case 'K': absMatrix[8][j]++; break;
	    				case 'L': absMatrix[9][j]++; break;
	    				case 'M': absMatrix[10][j]++; break;
	    				case 'N': absMatrix[11][j]++; break;
	    				case 'P': absMatrix[12][j]++; break;
	    				case 'Q': absMatrix[13][j]++; break;
	    				case 'R': absMatrix[14][j]++; break;
	    				case 'S': absMatrix[15][j]++; break;
	    				case 'T': absMatrix[16][j]++; break;
	    				case 'V': absMatrix[17][j]++; break;
	    				case 'W': absMatrix[18][j]++; break;
	    				case 'Y': absMatrix[19][j]++; break;
	    			}
    			}else if (numLetters == 5){
    				switch(letter){
    					case 'A': absMatrix[0][j]++; break;
	    				case 'C': absMatrix[1][j]++; break;
	    				case 'G': absMatrix[2][j]++; break;
	    				case 'T': absMatrix[3][j]++; break;
	    				case '-': absMatrix[4][j]++; break;
	    			}
    			}else if (numLetters == 4){
    				switch(letter){
						case 'A': absMatrix[0][j]++; break;
	    				case 'C': absMatrix[1][j]++; break;
	    				case 'G': absMatrix[2][j]++; break;
	    				case 'T': absMatrix[3][j]++; break;
	    			}
				}
    		}
    	}
    	
    	return absMatrix;
    }
	private double[][] createFreqMatrix(int absMatrix[][]){
    	int numLetters = absMatrix.length;
    	int longSeq = absMatrix[0].length;
    	double[][] freqMatrix = new double[numLetters][longSeq];
    	int numSeq = 0;
    	
    	// initialize freqMatrix to 0s
    	for (int i=0; i<numLetters; i++){
    		for (int j=0; j<longSeq; j++){
    			freqMatrix[i][j] = 0;
    		}
    	}
    	
    	// get number of sequences
    	numSeq = getNumSeq(absMatrix);
    	
    	// divide absolute freqs by num of seqs
    	for (int i=0; i<numLetters; i++){
    		for (int j=0; j<longSeq; j++){
    			freqMatrix[i][j] = functions.roundDecimals((double)absMatrix[i][j] / (double)numSeq, 2);
    		}
    	}
    	
    	return freqMatrix;
    }
	double[][] getFreqMatrix(){
		return freqMatrix;
	}
}
